import { OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { TimepickerConfig } from './timepicker.config';
export declare const TIMEPICKER_CONTROL_VALUE_ACCESSOR: any;
export declare class TimepickerComponent implements ControlValueAccessor, OnInit {
    hourStep: number;
    minuteStep: number;
    readonlyInput: boolean;
    mousewheel: boolean;
    arrowkeys: boolean;
    showSpinners: boolean;
    min: Date;
    max: Date;
    meridians: string[];
    showMeridian: boolean;
    onChange: any;
    onTouched: any;
    hours: string;
    minutes: string;
    invalidHours: any;
    invalidMinutes: any;
    meridian: any;
    protected _selected: Date;
    protected _showMeridian: boolean;
    protected selected: Date;
    protected config: TimepickerConfig;
    constructor(_config: TimepickerConfig);
    ngOnInit(): void;
    writeValue(v: any): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
    updateHours(): void;
    hoursOnBlur(): void;
    updateMinutes(): void;
    minutesOnBlur(): void;
    incrementHours(): void;
    decrementHours(): void;
    incrementMinutes(): void;
    decrementMinutes(): void;
    noIncrementHours(): boolean;
    noDecrementHours(): boolean;
    noIncrementMinutes(): boolean;
    noDecrementMinutes(): boolean;
    toggleMeridian(): void;
    noToggleMeridian(): boolean;
    protected refresh(): void;
    protected updateTemplate(): void;
    protected getHoursFromTemplate(): number;
    protected getMinutesFromTemplate(): number;
    protected pad(value: string | number): string;
    protected addMinutesToSelected(minutes: any): void;
}
