import { ChangeDetectorRef, ComponentRef, TemplateRef, ViewContainerRef, EventEmitter, Renderer, ElementRef, OnInit, OnDestroy } from '@angular/core';
import { ComponentsHelper } from '../utils/components-helper.service';
import { TooltipConfig } from './tooltip.config';
export declare class TooltipDirective implements OnInit, OnDestroy {
    content: string;
    htmlContent: string | TemplateRef<any>;
    placement: string;
    isOpen: boolean;
    enable: boolean;
    animation: boolean;
    appendToBody: boolean;
    popupClass: string;
    tooltipContext: any;
    delay: number;
    fadeDuration: number;
    tooltipTrigger: string | Array<string>;
    tooltipStateChanged: EventEmitter<boolean>;
    protected visible: boolean;
    protected tooltip: ComponentRef<any>;
    protected delayTimeoutId: number;
    protected toggleOnShowListeners: Function[];
    protected viewContainerRef: ViewContainerRef;
    protected componentsHelper: ComponentsHelper;
    protected changeDetectorRef: ChangeDetectorRef;
    protected renderer: Renderer;
    protected elementRef: ElementRef;
    protected config: TooltipConfig;
    constructor(viewContainerRef: ViewContainerRef, componentsHelper: ComponentsHelper, changeDetectorRef: ChangeDetectorRef, renderer: Renderer, elementRef: ElementRef, config: TooltipConfig);
    ngOnInit(): void;
    protected configureOptions(): void;
    protected bindListeners(): void;
    protected normalizeEventsSet(events: string | string[]): string[];
    show(e: MouseEvent | FocusEvent): void;
    hide(): void;
    protected triggerStateChanged(): void;
    protected preventAndStop(event: MouseEvent | FocusEvent): void;
    ngOnDestroy(): void;
}
